<H1>Ecrire des clients Freenet en utilisant la bibliothque java Freenet.client.Client.</H1>

<h2>Brouillon 1.1.</h2>



<h3>0 Intro</h3>

La bibliothque de rfrence implmente pour le client Frenet est un coeur flexible et puissant qui permet de construire les clients. Il partage la plupart de son code (rseau, cryptage, threads) avec le node de rfrence de Freenet ('Fred'). La flexibilit signifie qu'il faut plus d'tapes pour une Insertion ou une Requte mais c'est ce qui la rend intgrable dans n'importe quoi, du GUI au convertisseur de proxy ou remailer.

<h4>0.1 Lgal</h4>

Ce document complet, hormis quelques guillemets clairement indiqus, est crit par Oskar Sandberg. Il est protg par la GNU General Public License (le document!). 

<h4>0.2 Corrections, Questions, Critiques, etc...</h4>

Vous pouvez me les communiquer sur mon  email 
<pre>
perl -e 'print(pack("h*","d6469383d2f6371604e6164616e2b64786e23756"));'
</pre>
ou rcuprez-les avec la liste de diffusion de frenet-dev
(http://lists.sourceforge.net/mailman/listinfo/freenet-dev).

<h3> Prparation Gnrale</h3>

<h4>1.1 Le Coeur</h4>

Pour que le client puisse travailler, il a besoin d'un coeur client pour traiter les services de base (c'est la partie qui est partages avec le serveur Freenet).
Les Coeurs Freenet peuvent tre trs flexibles et supporter diffrents types de transports et diffrents protocoles mais la plupart des clients n'auront besoin que d'un coeur de base pour supporter le protocole Freenet standard avec un TCP/IP. Pour l'efficacit, les Coeurs devront tre partags entre toutes les requtes faites par le client - il est recommand d'en crer un lorsque vous dmarrez votre client et gardez le vivant jusqu' la fin. 
<p>
Il existe deux mthodes Freenet.client.ClientUtil.getTCPCore() qui retournent un Coeur. La premire ne prend qu'un entier de la valeur du port que le Coeur devrait utiliser pour les messages entrants comme paramtres (et s'il est  0, il sera choisi alatoirement). La seconde mthode vous permet aussi de spcifier un jeu de paramtres et un Logger. Les clients peuvent habituellement sortir sans se connecter ou de spcifier des paramtres et la premire mthode convient trs bien pour ces situations, auquel cas , vous pouvez sauter directement au 1.2. 

<h5>1.1.1 Paramtres</h5>

Le coeur Freenet peut utiliser un jeu de paramtres, de la forme d'objets Freenet.Params. Un objet param peut tre cr par un constructeur vide, un de ceux qui prend une chane (qui est suppose tre de la forme "-<name>[=]<value> "), un fichier (avec un format ayant des proprits java, ie
"<name>=<value>", dlimit par un EOL et avec # pour les commentaires) ou comme toute combinaison des deux. Une fois que l'objet est cr, vous pouvez fixer les valeurs des paramtres en utilisant la mthode : 
<pre>
    setParam(String name, String value);
</pre>
Ici, vous avez les paramtres qui relvent du client (pris sur le fichier sample.freenetrc). Si vous n'en comprenez pas la signification, vous n'avez pas de raisons de les changer :
<pre>
# Le nombre de millisecondes entre les pulses sur le timer
tickerTime=500
# Le temps attendu et la dviation standard, en millisecondes, qu'il faut  
# un node Freenet pour passer le message. Ils sont utiliss pour calculer 
# combien de temps le node doit attendre avant de supposer que le message pass 
# est perdu. 
# Ils sont surtout ici pour des raisons de dbuggage -les changer NE fera PAS 
# arriver les requtes plus vite.
hopTimeExpected=12000
hopTimeDeviation=12000
# Temps d'attente pour l'authentication avant l'abandon (en millisecondes)
authTimeout=30000
# Temps d'attente de connexion avec un hte avant l'abandon (en millisecondes)
connectTimeout=2000
# Temps d'attente d'coute sur une connexion inactive avant la fermeture (si
# l'adresse de rponse est connue).
connectionTimeout=300000
# Laissez ceci  "yes"  moins que vous ne fassiez du dbuggage de timeout.
doHandshake=yes
# temps d'attente pour une reconnaissance rciproque (en millisecondes)
handshakeTimeout=30000
# temps d'attente avant l'expiration d'une reconnaissance rciproque 
# (en millisecondes)
handshakeLife=10000000
# Devons-nous utiliser la gestion des threads?  Si ce nombre est dfini et 
# diffrent de zro, il spcifie combien de connexions entrantes peuvent tre 
# actives au mme moment.
maximumConnectionThreads=50
# Un liste de paire de nombres de types de cls pour les plugins de types de cls
#keyTypes=0101 : Freenet.keys.KHK
</pre>
Tout paramtre non tabli aura sa valeur par dfaut. Aucun de ceux-ci ne sont ncessaires pour faire tourner un client. 

<h4>1.1.2 Connexion</h4>

Le Coeur Freenet connectera son tat intrieur  un objet implmentant l'interface Freenet.support.Logger. La mthode importante est :
<pre>
    /**
     * Log a message
     * @param source   L'objet source o ce message a t gnr
     * @param message  Un message clair et prolixe dcrivant l'vnement
     * @param priority La priorit du message, un de Logger.ERROR,
     *                 Logger.NORMAL, Logger.MINOR, ou Logger.DEBUGGING.
     **/
    public abstract void log(Object source, String message, int priority);
</pre>
En gnral, les clients ont seulement besoin de garder une trace des logs internes du Coeur de manire  surveiller les bugs et faire des reports de bugs (et il y aura des bugs). Les niveaux de priorits sont les suivants :
<pre>
    /** Ce message indique une erreur qui empche le fonctionnement correct**/
    public static int ERROR = 3;
    /** Un vnement de niveau normal **/
    public static int NORMAL = 2;
    /** Un vnement mineur qui n'est pas normalement intressant **/
    public static int MINOR = 1;
    /** Un vnement qui n'est intressant que pour le dbuggage **/
    public static int DEBUGGING = 0;
</pre>
Un bon client doit probablement garder un log de tous les messages, incluant le dbuggage, invisible pour nous aider lors du report de bugs -mais cela n'est pas ncessaire. Mme les entres de log au niveau des ERREURS doivent tre ignores, comme les clients dtecteront les problmes et des vnements envoys (voir section 5) en accord lorsque les erreurs surviennent. 

<h3>1.2 Adresse</h3>

Pour crer un client, vous aurez aussi besoin de lui donner l'adresse du node Freenet auquel il doit tre connect (comme vous l'avez dj entendu, il est fortement recommand que ce soit un node local sur la machine utilisateur).
Les objets Freenet.Address sont des wrappers dont les adresses sont indpendantes du protocole mais comme nous travaillons avec TCP/IP seulement, vous pouvez utiliser la mthode Freenet.client.ClientUtil.getAddress pour crer un tel objet. Les arguments sont soit des java.net.InetAddress et un numro de port, une chaine avec un nom d'hote et un numro de port ou une chaine dlimite par des virgules.

<h3>1.3 Bibliothque client</h3>

Un fois que vous avez un Coeur et une Adresse, vous pouvez construire une bibliothque client en utilisant le constructeur :
<pre>
    public Client(ClientCore core, Address target);
</pre>
Vous pouvez utiliser le mme objet Freenet.client.Client pour plusieurs requtes mais vous aurez  en crer un nouveau si vous voulez vous connecter  un node diffrent (mais vous gardez le Coeur).

<h2>2 Cls</h2>

Les cls sont l'ossature de Freenet. Pour insrer ou faire une requte de donne, vous aurez besoin d'une cl. Les cls peuvent avoir plusieurs formes et tailles. Cette section ne traite que de la cration des cls pour les clients, pour la documentation sur les types de cls et la manire dont elles fonctionnent, voir le document "Bestiaire des Cls".

<h3>2.1 URI Freenet</h3>

Les URI Freenet sont dfinis comme :
<pre>
freenet:[KeyType@]KeyValue[,DecryptionKey]
</pre>
pour CHK, SVK, et KSK, bien que KSK n'a pas de DecryptionKey et ne ncessite pas de type de cl car ils en ont par dfaut. Pour les SSK, le format est un peu diffrent :
<pre>
freenet:SSK@DocumentName,SubspaceKey
</pre>
Il y a une classe Freenet.client.FreenetURI qui peut tre utilise pour dcrire les URI Freenet. Elle peut tre construite  partir de la valeur de la chane et peut aussi retourner une chane dans ce format  partir des cls. La plus importante mthode pour vous est :
<pre>
    getKeyType()
</pre>
qui vous dira quel type de cl dcrit l'URI et
<pre>
    toString() 
</pre>
pour les cls de sortie cres par le client. 

<h4>2.1.1 Freenet Base64</h4>

Pour les cls qui contiennent des donnes binaires (toutes except KSK), Freenet utilise une version modifie de Base64 qui ne contient pas de caractre ayant une signification spciale pour les URI et enlve la ncessit d'avoir une donne avec un multiple de 4 caractres de long. L'alphabet base64 utilis est :
<pre>
  private static char[] base64Alphabet = {
    'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
    'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
    'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
    'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
    'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
    'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
    'w', 'x', 'y', 'z', '0', '1', '2', '3',
    '4', '5', '6', '7', '8', '9', '~', '-'};
</pre>
car les bibliothques du client les coderont et dcoderont elles-mme et vous n'aurez pas  vous en proccuper. Si c'est le cas, il existe une classe qui fait le codage et le dcodage de ce format dans Freenet.client.Base64.

<h3>2.2 CHK - Cl de Hachage de Contenu</h3>

L'objet qui dcrit les CHK au client est Freenet.client.ClientCHK.

<h4>2.2.1 Crer un CHK  l'insertion.</h4>

Les cls  Hachage de Contenu tant bases sur le hachage des donnes, l'utilisateur n'a pas besoin (ne peut pas) donner de valeur  la cl. Pour crer un CHK pour l'insertion, vous devez utiliser le constructeur :
<pre>
    public ClientCHK(InputStream in, long plainLength);
</pre>
Le flux d'entre doit contenir la donne mais il sera consomm lorsque la cl sera produite. Cela ne pourrait pas tre les mmes donnes que vous donnerez au client plus tard pour l'insertion (en d'autre mots, vous devrez avoir les donnes dans un fichier quelconque).

<h4>2.2.2 Obtenir la valeur CHK.</h4>

La valeur complte de CHK ne sera pas connue avant que les bibliothques client n'aient t appeles. Lorsque la donne a t insre, vous pouvez appeler la mthode getURI() pour retourner l'URI complte ncessaire pour demander le CHK.

<h4>2.2.3 Crer un CHK  la requte.</h4>

Lors de la requte d'un CHK, l'URI aura besoin de contenir toutes les donnes pour la cl, vous utilisez donc simplement le constructeur :
<pre>
    public ClientCHK(FreenetURI uri) throws KeyException;
</pre>
<h3>2.3 SVK -Cl  Vrification de Signature</h3>

La classe qui dcrit SVK pour les clients est Freenet.client.ClientSVK. Les SVK deviendrons actifs lorsque la mise  jour sera implmente, auquel cas une documentation supplmentaire sera ncessaire pour les utiliser. 

<h4>2.3.1 Crer un SVK  l'insertion.</h4>

Pour les insertions, une nouvelle cl prive et publique sera gnre pour crer un nouveau SVK. Pour ce faire, vous devez utiliser le constructeur :
<pre>
    public ClientSVK(Random r) throws KeyException;
</pre>
O l'implmentation java.util.Random est utilise pour gnrer les valeurs de cls. Vous pouvez utiliser les implmentations Freenet de la cryptographie Yarrow PRNG en utilisant le champ randSource de votre Coeur (voir 1.1) comme argument.

<h4>2.3.2 Avoir la valeur gnrale SVK.</h4>

Le SVK complet ne sera pas gnr jusqu' ce que les bibliothques clients soient appeles mais aprs que les donnes aient t insres, vous pouvez appeler la mthode getURI() de l'objet ClientSVK pour retourner l'URI complet ncessaire pour demander le SVK.

<h4>2.3.3 Obtenir la cl prive gnre pour un SVK.</h4>

Lorsqu'un SVK est gnr, une cl Prive est cre en mme temps. La cl prive peut tre utilise pour insrer des donnes dans les sous-espaces bass sur SVK (voir ci-dessous) et dans le futur pour mettre  jour les donnes indexes SVK. Aprs que l'insertion soit faite, vous pouvez obtenir la valeur de la cl prive en utilisant la mthode getPrivateKey() de l'objet client ClientSVK (getPrivateKeyString() le renverra cod par base64).

<h4>2.3.4 Crer un SVK  la requte.</h4>

Comme pour les requtes, SVK peut tre cr directement  partir de l'URI lors de la demande. Utilisez simplement le constructeur :
<pre>
    public ClientSVK(FreenetURI key) throws KeyException;
</pre>

<h3>2.4 KSKs - Cls  Signature par Mot Cl</h3>

La classe qui dcrit KSK pour le Client est Freenet.client.Client.

<h4>2.4.1 Crer un KSK pour une insertion</h4>

Pour crer un KSK, vous aurez besoin de la valeur du mot cl et d'une implmentation alatoire (voir le SVK ci-dessous). Utilisez le constructeur :
<pre>
    public ClientKSK(Random r, String keyword) throws KeyException;
</pre>

<h4>2.4.2 Crer un KSK pour les requtes</h4>

Comme pour les autres de types de cls, utilisez simplement le constructeur  partir de l'URI :
<pre>
    public ClientKSK(FreenetURI key) throws KeyException;
</pre>

<h3>2.5 SSKs - Cls SVK  Sous espace</h3>

Une fois gnre, un SVK peut tre utilis comme la racine d'un sous-espace, o la cl prive est ncessaire pour insrer des documents dans le sous espace mais dont seule la cl publique est ncessaire pour les demandes. SSK est dcrit dans la bibliothque Client par la classe Freenet.client.ClientSSK.

<h4>2.5.1 Crer un SSK pour l'insertion.</h4>

Lors de l'insertion d'un SSK, vous avez besoin du constructeur :
<pre>
    public ClientSSK(Random r, FreenetURI key) throws KeyException
</pre>
Random est comme pour SVK mais FreenetURI, dans ce cas est un URI Freenet spcial de la forme : 
<pre>
freenet:SSK@<document name>,<SVK private key>
</pre>
Notez que la seconde partie est la cl prive ncessaire pour les insertions dans le sous espace (voir 2.3.3) pas la cl de sous espace publique comme dans l'URI qui est rendue publique et est utilise pour demander des donnes. 

<h4>2.5.2 Obtenir la valeur SSK.</h4>

Les valeurs URI SSK seront les mme que l'URI utilis pour construire le ClientSSK mais avec la partie de la &lt;cl prive de SVK&gt; remplace par la cl publique SVK correspondante. La valeur peut tre retrouve en appelant la mthode getURI() de l'objet ClientSSK.

<h4>2.5.2 Crer un SSK pour les requtes.</h4>

Comme pour toutes les autres cls, lors des requtes vous pouvez construire le SSK directement  partir de l'URI :
<pre>
    public ClientSSK(FreenetURI key) throws KeyException;
</pre>

<h2>3 Prparer un InsertRequest</h2>

Les insertions sont prpares en appelant la mthode prpare de l'objet Client (voir 1.1 - 1.3) avec les paramtres :
<pre>
     * @param htl   Le nombre de HopsToLive  donner au message.
     * @param data  Un flux de donnes  insrer.
     * @param dataLength  Le nombre d'octets de donnes  insrer.
     * @param metadata    Un flux Freenet de mtadonne de document standard.
     * @param metadataLength  La longueur de la mtadonne  insrer.
     * @param ckey    Un objet ClientKey  insrer.
     * @param cipherName  Le bloc de chiffres  utiliser.
     * @param ctBucket    Un place pour stocker le CipherText comme il a t trait.
</pre>
La mthode va retourner un objet RequestToken qui peut tre utilis pour ajouter des listes d'vnements et rellement dmarrer InsertRequest/DataRequest.

<h3>3.1 Hops To Live</h3>

Une demande d'insertion a besoin du nombre de hops to live, qui est le nombre de nodes que le message doit atteindre. Le hops to live d'un message insr peut tre gnralement un peu plus grand que pour une requte mais alors pas plus de 20-25 ne seront ncessaires. La limite actuelle de HTL sur Freenet est de 100.

<h3>3.2 Donne</h3>

Pour insrer quelque chose, vous aurez besoin d'un InputStream de la donne en question. La donne ne sera pas lue directement  partir de ce flux vers Freenet mais plutt lue pour tre crypte et hache dans un conteneur (voir ci-dessous)  partir duquel il est insr (vous pouvez donc utiliser ce flux comme indication pour savoir combien de donnes ont t insres).

<h3>3.3 Longueur de la donne</h3>

La somme de donne  lire  partir du flux dans 3.2.

<h3>3.4 Mtadonne</h3>

Ceci doit tre un flux de mtadonnes  insrer avant les donnes sur Freenet.
Pour mmoire, ce sont des mtadonnes prives, invisibles pour tout le monde except pour ceux qui ont demand le document. Les standards pour les mtadonnes Freenet sont documentes ailleurs.
<p>
Si vous n'avez pas de mtadonne, donnez un flux et placez la longueur des mtadonnes  zro.

<h3>3.5 Longueur des mtadonnes</h3>

La somme des mtadonnes  lire du flux en 2.4. S'il n'y a pas de mtadonnes, c'est positionn  zro. 
<h3>3.6 Cl</h3>

La cl pour insrer la donne de la forme d'un objet Freenet.client.ClientKey. Voir section 2 pour la mthode de gnration de diffrents types de cls.

<h3>3.7 Nom de chiffrement</h3>

Ceci devrait tre le nom du chiffrement utilis pour crypter la donne. Actuellement, les chiffrements utiliss sont Twofish et Rijndael, avec Rijndael (AES) recommend.

<h3>3.8 Chiffrement Bucket</h3>

La bibliothque client a besoin de passer les donnes deux fois, une fois pour crypter et calculer un hachage sur le texte chiffr, une seconde fois pour rellement insrer le texte chiffr. C'est pourquoi le texte chiffr doit tre stock entre les deux. Pour avoir le plus de flexibilit possible, vous pouvez donner  la bibliothque toute instance implmentant l'interface Freenet.support.Bucket. Pour y stocker les donnes. 
<p>
Il existe dj deux implmentations de conteneurs dans Freenet.support. FileBucket est un simple conteneur qui place les donnes dans un fichier sur le disque et Cryptbucket fera la mme chose mais cryptera les donnes une seconde fois avec une cl alatoire alors qu'il est encore sur le disque (c'est pour protger l'utilisateur d'une recherche de donne sur le disque prouvant qu'il a insr les donnes). Notez que si vous les utilisez avec un constructeur qui cre un fichier temporaire, vous aurez besoin d'appeler Freenet.support.OnExitCleanup.doCleanUp() avant de quitter le fichier devant tre effac - si votre cible est java 1.2, vous feriez mieux de crer un fichier temporaire vous mme avec la mthode JFC et lui donner File ou CryptBucket.


<h2>4 Prparing un DataRequest</h2>

Les requtes sont prpares en appelant la mthode prpare de l'objet Client (voir 1.1-1.3) avec les paramtres suivants : 
<pre>
     * @param htl  Le HopsToLive  donner  la requte.
     * @param ck    L'objet cl  demander.
     * @param data  Un conteneur pour y placer les donnes
     * @param metaData Un conteneur pour placer les mtadonnes (s'il y en a)
</pre>
Cette mthode retournera un RequestToken auquel vous pourrez ajouter une liste d'venements et rellement dmarrer la requte. 

<h3>4.1 Hops to live</h3>

C'est le nombre de nodes auquelle la requte doit tre envoye. Si Freenet est sain et que la donne est disponible, vous n'aurez pas besoin d'une valeur suprieure  15-20 pour trouver la donne. Le maximum absolu que Freenet permet est 100.

<h3>4.2 Cl</h3>

La cl pour la requte, comme dcrit par Freenet.client.ClientKey object. Voir la section 2 pour des information sur la manire de crer des objets ClientKey.

<h3>4.3 Conteneur de donne</h3>

Le client a besoin de charger toutes les donnes avant de vrifier qu'elles sont correctes, il a donc besoin de place pour le stockage. Pour la flexibilit, vous pouvez fournir toute implmentation de l'interface Freenet.support.Bucket pour ce but. 
<p>
Il y a dj deux implmentations Bucket (conteneur) dans Freenet.support, voir 3.8 pour plus d'informations.

<h3>4.4 Conteneur de mtadonne</h3>

Comme pour les donnes, le client ncessite de placer les mtadonnes quelque part pendant les vrifications. Vous devez donc fournir un conteneur pour ceci aussi. Les mtadonnes sont gnralement petites, il est donc plus efficace d'utiliser un conteneur qui les stocke en mmoire puis sur le disque. 



<h2>5 ClientEventListeners</h2>

Lorsqu'une requte (InsertRequest ou DataRequest) est excute, elle gnrera des vnements qui peuvent tre pris pour lire le status de l'excution. Chaque vnement sera une implmentation de Freenet.client.ClientEvent et de manire  les stocker, vous aurez besoin d'un objet qui implmente le 
Freenet.client.ClientEventListener que vous pouvez ajouter au RequestToken gnr aux tapes 3 ou 4, en utilisant :
<pre>
    public void addEventListener(ClientEventListener cel);
</pre>
Vous pouvez ajouter autant de listes d'vnement que vous le souhaitez. Il y a actuellement une ClientEventListener implmente avec la bibliothque client, EventLogger, qui enverra chaque vnement toString() vers un objet Logger (voir 1.1.2).

<h3>5.1 Evnements</h3>

Les vnements gnrs par la bibliothque client sont tous dans le paquetage Freenet.client.events. Chacun a sa propre classe mais aussi un nombre unique. Nous fournissons une liste des vnements par numro et leur signification :
<pre>
	0	StateReached Event.
</pre>
C'est envoy lorsque l'tat du client change. L'tat est dcrit par un int, qui peut tre converti en un nom avec la mthode :
<pre>
    Client.stateOf(int state);
</pre>
Les tats possibles sont :
<pre>
    public static final int INIT = 0;
    public static final int PREPARED = 1;
    public static final int REQUESTING = 2;
    public static final int TRANSFERING = 3;
    public static final int DONE = 4;

    public static final int FAILED = -1;
</pre>
L'tat du client progresse gnralement mais peut rgresser du TRANSFERT vers la REQUETE si les donnes ne sont pas vrifies. DONE et FAILED sont les termes finaux. 
<pre>
	1	SendEvent
</pre>
Un messsage a t envoy sur Freenet. La mthode getMessageName() de cette classe retourne le type de message qui a t envoy. 
<pre>
	2	ReceiveEvent
</pre>
Un message a t reu de Freenet. La mthode getMessageName() de cette classe retourne le type du message qui a t reu.
<pre>
	3	ExceptionEvent
</pre>
Une exception s'est produite pendant l'excution du client. Les types les plus communs d'exceptions sont les ConnectionExceptions si la connexion vers l'adresse spcifie choue ou NullPointers si vous envoyez un null quelque part o vous ne le devriez pas. La classe possde une mthode rethrow() qui retrace toujours l'exception en question (donc vous en avez une trace dans la pile). 
<pre>
	4	RestartedEvent
</pre>
Chaque node Freenet garde une trace du prcdent et s'assure des rponses en temps voulu et que les donnes renvoyes sont correctes. Si un node ne rpond pas  une requte (donne/insertion) ou rpond incorrectement, le dernier bon node va redmarrer et renverra un message vers les nodes prcdents pour leur signifier qu'ils peuvent reseter leurs horloges. Lorsqu'un tel message atteint le client, un RestartedEvent se produira.  
<p>
C'est ce qui devrait se produire avec un NoReplyEvent (10). L'vnement 10 signifie plus ou moins : "Je (le client) suis le dernier bon node et je ne peut pas faire grand chose".
<pre>
	5	RequestSuccessfulEvent
</pre>
Ceci indique que les donnes demandes ont t trouves ou qu'un chemin pour insrer les donnes a t trac. Lorsque cet vnement se produit, la bibliothque dmarre rellement le transfert de donnes. Ceci n'indique pas que la transaction est complte - dans le cas d'une requte, la donne peut tre corrompue auquel cas, le rseau redmarrera.
<pre>
	6	RequestFailedEvent
</pre>
Ceci se produit lorsqu'un DataRequest ou un InsertRequest choue normalement, ie un message a t reu du rseau, rejetant la requte. La mthode getMessage() retournera le message en question mais seul le type sera intressant pour la plupart des clients.
<p>
A l'insertion :
<p>
Un "DataReply" signifie la mme chose qu'un CollisionEvent ci-dessous - la donne pour cette cl a dj t trouve sur Freenet.
<p>
A "TimedOut" signifie aussi que la cl a t trouve mais dans ce cas, la donne n'a pas t trouve (ceci peut servir pour tre une rponse valide sur les insertions ds qu'il y a de l'insecurit - les nodes n'ont pas  sauvegarder la demande avec la donne pour le prouver.).
<p>
Un "RequestFailed" signifie que InsertRequest a t sur tous les nodes qu'il pouvait atteindre sur tout Freenet avant que le hops to live soit puis. Ceci ne devrait pas se produire sur un rseau de plus de 10 nodes et donc, si cela se produit, le node utilisateur est probablement dconnect du rseau principal. 
<p>
A la requte :
<p>
Un "TimedOut" signifie que la DataRequest a fait tous les nodes demands mais que la donne n'a pas t trouve. Augmenter le hops to live peut aider mais aller au dela de 25-30 ne fera pas de diffrence. <p>
Un "RequestFailed" signifie la mme chose que pour le InsertRequest.
<pre>
        7       CollisionEvent
</pre>
La cl a dj t trouve comme tant sur Freenet lors d'une tentative d'insertion. Pour SVK, KSK et SSK, ceci peut signifier que d'autre donnes sont dj sur Freenet mais pour CHK cela signifie que la donne exacte est dj et l'utilisateur n'a plus qu' se connecter/rediriger/utiliser la donne  la place. 
<pre>
	10	NoReplyEvent
</pre>
C'est gnr lorsqu'il n'y a pas de rponse de Freenet aprs un temps calcul par une formule standard (intervale de confiance de 90% d'un temps de saut avec une dviation de 12 secondes pour chaque saut). Si le node avec lequel vous dialoguez travaille correctement, vous devriez toujours avoir des rponses  l'intrieur de ce temps (attention : nos nodes sont connus pour ne pas toujours travailler correctement). Si vous vous embtez avec les paramtres de hopTimeExpected et hopTimeDeviation, vous pouvez les avoir dans la section 1.1.1.
<pre>
	16	ErrorEvent
</pre>
Une erreur s'est produite dans la bibliothque client. Cela signifie que nous avons fait des erreurs et aprs avoir contrl le commentaire et vous tes assur que vous n'avez rien envoy de bizarre au client, vous pouvez valider un rapport de bug. 
<pre>
	128	TransferStartedEvent
</pre>
Cet vnement indique que le transfert de donne est dmarr. 
<pre>
	129	TransferedEvent
</pre>
Ces vnements sont produits  intervalles rguliers alors que la donne a t transfre. La mthode getProgress() retourne un nombre d'octets jusqu'ici lus ou crits. 
<pre>
	130	TransferCompleteEvent
</pre>
Cet vnement indique qu'un transfert de donne a t ralis avec succs. 
<pre>
	131	RequestCompleteEvent
</pre>
Cet vnement est produit lorsque toutes les donnes que vous aviez demand ont t reues avec succs et que le message final a t accept. Flicitations! :-)
<pre>
	132 	SegmentCompleteEvent	
</pre>
Cet vnement indique qu'un segment de donne a t transmis. Actuellement, Freenet a deux segments (mtadonnes et donnes). Notez que cet vnement *NE* garanti *PAS* que les donnes dans le segment sont correctes. C'est seulement aprs un RequestCompleteEvent que l'on peut supposer que la donne est intacte. 

<h2>6 Excuter les requtes</h2>

Lorsque vous avez ajout un ClientEventListeners (voir section 5) au RequestToken produit dans les sections 3 ou 4, vous tes prts pour excuter la requte. Tout ce que vous avez besoin de faire est d'appeler la mthode  
<pre>
    makeRequest(RequestToken rt)
</pre>
du mme objet Client obtenu de RequestToken.
La requte se produira d'une manire asynchrone dans un autre thread, donc tout ce qu'il faut faire est d'attendre et regarder les vnements produits. Si vous voulez attendre que les vnements soient termins, vous pouvez crire un EventListener simple qui vous reveille lorsqu'il atteint un StateReachedEvent (voir 5.1, Event 0) positionn  DONE ou FAILED et aller dormir. 

